/****************************************************************************
 *
 * RepeatActivity.hh
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/
#ifndef BPEL_REPEATACTIVITY_HH
#define BPEL_REPEATACTIVITY_HH

#include "Activity.hh"

class RepeatActivity : public Activity {
protected:
    double m_prob; ///< the probability that the condition is true
    Activity* m_inner;
public:
    RepeatActivity( const std::string& name );

    virtual ~RepeatActivity( ) { };

    void describe( void ) const;

    void accept( ActivityVisitor* v );

    double get_prob( void ) const { return m_prob; };

    /**
     * Gets the inner activity, which is executed as long as the
     * condition remains true.
     */
    Activity* get_inner( void ) { return m_inner; };

    void set_inner( Activity* a ) { m_inner = a; };

    void set_prob( double p ) { m_prob = p; };
};

#endif
