/****************************************************************************
 *
 * WSDLFactory.hh
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/
#ifndef BPEL_WSDLMODEL_HH
#define BPEL_WSDLMODEL_HH

extern "C" {
#include <libxml/tree.h>
}

#include <string>
#include <list>

class WSDLOperation;

class WSDLFactory {
protected:

    WSDLOperation* make_operation( xmlNodePtr n );

    std::list< WSDLOperation* > m_operations;

    void parse_wsdl( xmlDocPtr doc );

public:
    WSDLFactory( const std::string& fname );

    ~WSDLFactory( );

    std::list< WSDLOperation* > get_operations( void ) const;
};

#endif
