/****************************************************************************
 *
 * WSDLOperation.cc
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/
#include "WSDLOperation.hh"
#include <iostream>
#include <iomanip>

using namespace std;

int WSDLOperation::s_id = 0;

WSDLOperation::WSDLOperation( const string& name ) :
    m_name( name ),
    m_id( s_id++ )
{

}

void WSDLOperation::set_service_time( const string& resource_name, double val )
{
    m_service_time[ resource_name ] = val;
}

double WSDLOperation::service_time( const string& resource_name ) const 
{
    map< string, double >::const_iterator it( m_service_time.find( resource_name ) );
    double result = 0;
    if ( m_service_time.end() != it ) {
        result = it->second;
    }
    return result;
}

void WSDLOperation::describe( void ) const {
    cout << "WSDL Operation: \"" << get_name() << "\"\tid: " << get_id() << endl;
    map< string, double >::const_iterator it;
    for ( it=m_service_time.begin(); it != m_service_time.end(); ++it ) {
        cout << "  Res. " << setw(10) << left << it->first
             << "\tAv. Serv. Time " << setw(10) << setprecision(2) << fixed << it->second 
             << endl;
    }
}
