/****************************************************************************
 *
 * bpel2qnbound.cc
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include <iostream>
#include "BPELModelFactory.hh"
#include "ServiceDemandVisitor.hh"
#include "BPELModel.hh"
#include "Activity.hh"

using namespace std;

int main( int argc, char* argv[] )
{
    LIBXML_TEST_VERSION;
    if ( 3 != argc ) {
        cerr << "Usage: " << argv[0] << " <BPEL file> <output_base_name>" << endl << endl
             << "This will produce the output files:" << endl
             << "<output_base_name>_tput_ab.gp   Asymptotic Bound for Throughput" << endl
             << "<output_base_name>_tput_bsb.gp  Balanced System Bound for Throughput" << endl
             << "<output_base_name>_resp_ab.gp   Asymptotic Bound for Response Time" << endl
             << "<output_base_name>_resp_bsb_gp  Balanced System Bound for Response Time" << endl;
        return -1;
    }
    BPELModelFactory f( argv[1] );
    BPELModel* m = f.get_bpel_model();
    ServiceDemandVisitor v;
    m->accept( &v );
    v.describe( argv[2] );

    return 0;
}
